import * as vue from 'vue';
import { RuntimeCompilerOptions, Component } from 'vue';

interface Props extends Record<string, any> {
}
interface VueRuntimeCompilerOptions extends RuntimeCompilerOptions {
}
interface SourceOptions {
    /**
     * The source code of the component.
     */
    source: string;
    /**
     * The components used in the component.
     */
    components: {
        name: string;
        source: string;
    }[];
}

declare const _default: {
    Button: vue.DefineComponent<{
        px: {
            type: vue.PropType<string | number>;
        };
        py: {
            type: vue.PropType<string | number>;
            default: number;
        };
        target: {
            type: StringConstructor;
            default: string;
        };
        href: StringConstructor;
        style: ObjectConstructor;
    }, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, vue.PublicProps, Readonly<vue.ExtractPropTypes<{
        px: {
            type: vue.PropType<string | number>;
        };
        py: {
            type: vue.PropType<string | number>;
            default: number;
        };
        target: {
            type: StringConstructor;
            default: string;
        };
        href: StringConstructor;
        style: ObjectConstructor;
    }>>, {
        py: string | number;
        target: string;
    }, {}>;
    Column: vue.DefineComponent<{}, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, {}, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, vue.PublicProps, Readonly<vue.ExtractPropTypes<{}>>, {}, {}>;
    Container: vue.DefineComponent<{}, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, {}, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, vue.PublicProps, Readonly<vue.ExtractPropTypes<{}>>, {}, {}>;
    Row: vue.DefineComponent<{}, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, {}, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, vue.PublicProps, Readonly<vue.ExtractPropTypes<{}>>, {}, {}>;
    Section: vue.DefineComponent<{
        style: {
            type: ObjectConstructor;
            default: () => {};
        };
    }, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, vue.PublicProps, Readonly<vue.ExtractPropTypes<{
        style: {
            type: ObjectConstructor;
            default: () => {};
        };
    }>>, {
        style: Record<string, any>;
    }, {}>;
};

declare function createEmailClient({ path, components, }: {
    path: string;
    components: Record<string, Component>;
}): {
    renderEmail: (name: string, props: Props, compilerOptions?: VueRuntimeCompilerOptions) => Promise<string>;
    addComponent: (name: string, component: Component) => void;
};

declare function templateRender(name: string, code: SourceOptions, props?: Props, compilerOptions?: VueRuntimeCompilerOptions): Promise<string>;

export { createEmailClient, _default as defaultComponents, templateRender };
